]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- (after hawk got his autotag) switch back to readlink but additionally translate...
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # compiler version
12 %cc_version             %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
13 %cxx_version    %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
14
15 %__rm                   /bin/rm --interactive=never
16
17 # Build system path macros.
18 #
19 %__autoconf             autoconf %{?debug:-Wall}
20 %__automake             automake -a -c -f --foreign
21 %__autopoint            autopoint --force
22
23 %__gettextize { \
24         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
25                 gettextize --copy --force --no-changelog; \
26         else \
27                 gettextize --copy --force --no-changelog --intl; \
28         fi; \
29         if [ ! -f po/Makevars ]; then \
30                 cp -f po/Makevars{.template,}; \
31         fi; \
32 }
33
34 %__glib_gettextize      glib-gettextize --copy --force
35 %__gnome_doc_common     gnome-doc-common --copy
36 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
37 %__gtkdocize            gtkdocize --copy
38 %__intltoolize          intltoolize --copy --force
39 %__libtoolize           libtoolize --copy --force
40
41 #       Path to top of build area.
42 %_topdir                %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
43
44 #       The number of cvs changelog entries kept when building package.
45 %_buildchangelogtruncate 20
46
47 %dependencytracking     %{nil}
48
49 #       Relations between package names that cause dependency loops
50 #       with legacy packages that cannot be fixed. Relations are
51 #       specified as
52 #               p>q
53 #       where package p has a Requires: on something that package q Provides:
54 #
55 # XXX   Note: that there cannot be any whitespace within the string "p>q",
56 #       and that both p and q are package names (i.e. no version/release).
57 %_dependency_whiteout   %{nil}
58
59 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
60         && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
61         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
62
63 #-----------------------------------------------------------------
64 #
65 # (re)definition of %{rpm*flags} with %filterout_* support
66 # BuildRequires:        awk
67 # BuildRequires:        rpmbuild(macros) >= 1.315
68 #
69 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
70 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
71 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
72 # %rpmldflags   = %optldflags - %filterout_ld
73 #
74 # Regular expressions are supported, but to avoid some character be treated
75 # as regular expression it must be escaped twice.
76
77 %filter_out                                             \
78         for (i = 1; i in I; i++) {      A=0;    \
79                 for (f in F) {                          \
80                         if (I[i] ~ "^" F[f] "$") A=1;   \
81                 };                                                      \
82                 if (!A) printf(I[i] FS);        \
83         }
84
85 %rpmcflags %(awk 'BEGIN {
86         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
87         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
88         %{filter_out}
89 }')
90
91 %rpmcxxflags %(awk 'BEGIN {
92         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
93         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
94         %{filter_out}
95 }')
96
97 %rpmldflags %(awk 'BEGIN {
98         split("%{?optldflags}",I);
99         split("%{?filterout_ld}",F)
100         %{filter_out}
101 }')
102
103 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
104 # but, don't use it, better use gcc as linker
105 %ld_rpmldflags %(awk 'BEGIN {
106         split("%{rpmldflags}",F);
107         for (f in F) {
108                 s = F[f];
109                 if (s ~ /^-Wl,/) {
110                         s = substr(s,5);
111                         gsub(/,/," ",s);
112                 };
113                 printf(s FS);
114         };
115 }')
116
117 #-----------------------------------------------------------------
118 %configure2_13 { \
119  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
120  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
121  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
122  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
123  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
124  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
125  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
126  %{?__cc:CC="%{__cc}" ; export CC ; } \
127  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
128  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
129         --host=%{_target_platform} \
130         --prefix=%{_prefix} \
131         --exec-prefix=%{_exec_prefix} \
132         --bindir=%{_bindir} \
133         --sbindir=%{_sbindir} \
134         --sysconfdir=%{_sysconfdir} \
135         --datadir=%{_datadir} \
136         --includedir=%{_includedir} \
137         --libdir=%{_libdir} \
138         --libexecdir=%{_libexecdir} \
139         --localstatedir=%{_localstatedir} \
140         --sharedstatedir=%{_sharedstatedir} \
141         --mandir=%{_mandir} \
142         --infodir=%{_infodir} \
143         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
144         %{dependencytracking} \
145 }
146
147 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
148 %__cmake        /usr/bin/cmake
149 %cmake { \
150 CC="%{__cc}" \
151 CXX="%{__cxx}" \
152 CFLAGS="%{rpmcflags}" \
153 CXXFLAGS="%{rpmcxxflags}" \
154 %{__cmake} \
155 }
156
157 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
158 %__scons        /usr/bin/scons
159 %scons { \
160 %{__scons} \
161         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
162         CFLAGS="${CFLAGS:-%rpmcflags}" \
163         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
164         FFLAGS="${FFLAGS:-%rpmcflags}" \
165         CPPFLAGS="${CPPFLAGS:-}" \
166         %{?__cc:CC="%{__cc}"} \
167         %{?__cxx:CXX="%{__cxx}"} \
168         libsuffix=%{_lib} \
169         prefix=%{_prefix} \
170 }
171
172 # waf. see waf.spec
173 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
174 %__waf  /usr/bin/waf
175 %waf { \
176 CC="%{__cc}" \
177 CXX="%{__cxx}" \
178 CPP="%{__cpp}" \
179 CFLAGS="%{rpmcflags}" \
180 CXXFLAGS="%{rpmcxxflags}" \
181 %{__waf} \
182 }
183
184 #----------------------------------------------------------------
185 #%configure_cache 0
186 %configure_cache_file   %{buildroot}.configure.cache
187
188 %configure {./configure \
189         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
190         CFLAGS="${CFLAGS:-%rpmcflags}" \
191         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
192         FFLAGS="${FFLAGS:-%rpmcflags}" \
193         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
194         CPPFLAGS="${CPPFLAGS:-}" \
195         %{?__cc:CC="%{__cc}"} \
196         %{?__cxx:CXX="%{__cxx}"} \
197         --host=%{_target_platform} \
198         --build=%{_target_platform} \
199         --prefix=%{_prefix} \
200         --exec-prefix=%{_exec_prefix} \
201         --bindir=%{_bindir} \
202         --sbindir=%{_sbindir} \
203         --sysconfdir=%{_sysconfdir} \
204         --datadir=%{_datadir} \
205         --includedir=%{_includedir} \
206         --libdir=%{_libdir} \
207         --libexecdir=%{_libexecdir} \
208         --localstatedir=%{_localstatedir} \
209         --sharedstatedir=%{_sharedstatedir} \
210         --mandir=%{_mandir} \
211         --infodir=%{_infodir} \
212         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
213         %{dependencytracking} \
214         %{?configure_cache:--cache-file=%{configure_cache_file}} \
215 }
216
217 # overload to insert debuginfo package
218 %prep \
219 %if 0%{?_enable_debug_packages}\
220 %{debug_package}\
221 %endif\
222 %%prep\
223 %{nil}
224
225 # Location of autoconf macros
226 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
227
228 # Location of omf files
229 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
230
231 # Location of pkgconfig files
232 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
233 # noarch pkgconfig files
234 %_npkgconfigdir /usr/share/pkgconfig
235
236 # Location of desktop files
237 %_desktopdir    /usr/share/applications
238 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
239
240 # Location of pixmaps for applnk/desktop files
241 %_pixmapsdir    /usr/share/pixmaps
242
243 # Location of themable icons for applnk/desktop files
244 %_iconsdir      /usr/share/icons
245
246 # Location of fonts directories
247 %_fontsdir      /usr/share/fonts
248
249 # Location of Gtk and associated libraries documentation
250 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
251
252 # Location of KDE documentation
253 %_kdedocdir     %{_defaultdocdir}/kde/HTML
254
255 # unsermake script
256 %__unsermake /usr/share/unsermake/unsermake
257
258 # Current date
259 %date           %(LC_ALL="C" date +"%a %b %d %Y")
260
261 # Example files, programs, scripts...
262 %_examplesdir   /usr/src/examples
263
264 # Alternative kernel type/version
265 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
266
267 # The directory holding Linux kernel sources
268 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
269
270 # If non-empty "debug" macro defined, add "dbg" suffix to release number
271 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
272
273 # Requires name = version-release
274 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
275
276 %releq_kernel                   %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
277 %releq_kernel_up                %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
278 %releq_kernel_smp()             %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
279 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
280 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
281 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
282
283 # XXX: why epoch 0 is stripped?
284 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
285 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
286
287 %apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
288
289 # kernel version-release handling
290 %__kernel_ver    %{expand:%%global __kernel_ver %( \\
291         Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
292         Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
293         echo ${Z:-ERROR}; \\
294 )}%__kernel_ver
295
296 %__kernel_rel   %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
297 %__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
298 %_kernel_ver    %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
299 %_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
300
301 # `uname -r` to be used in @release field
302 %_kernel_vermagic       %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
303
304 # sgml macros
305 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
306 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
307 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
308 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
309 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
310 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
311 %docbook_sgmlcat_fix() { for l in \
312 '' \
313 '  -- default decl --' \
314 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
315 '  -- hacks for opensp --' \
316 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
317 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
318 '' \
319 ; do echo $l; done >> %1 \
320 }
321
322 # vim - "
323
324 # minimum file size needed for compressed documents.
325 # just smaller files than this get larger when compressed.
326 # some stats:
327 # - 0 byte file compressed was 25 bytes .gz
328 # - 39 byte file was compressed as 57
329 # - with test/test.spec@man 158 byte file was compressed also 158
330 %_min_compress_bytes    159
331
332 #-----------------------------------------------------------------
333 # find and gzip all files in %{_mandir} and %{infodir}
334 #
335 # Requires: xargs, find
336 #
337 #%no_install_post_compress_docs 1
338 %__spec_install_post_compress_docs { \
339 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
340         for i in /usr/share/man /usr/X11R6/man; do \
341                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
342                         echo "Compress man pages: $i"; \
343                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
344                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
345                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
346                                 m=$(readlink $a); \
347                                 rm -f $a; \
348                                 echo .so ${m##*/} > $a; \
349                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
350                         done; \
351                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
352                 fi; \
353         done; \
354         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
355                 echo "Compress info pages: %{_infodir}"; \
356                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
357                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
358                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
359         fi; \
360 }; __spec_install_post_compress_docs } }
361
362 #-----------------------------------------------------------------
363 # Strip executable binaries and shared object files
364 #
365 # Requires: find, awk, strip, cut, xargs
366 #
367 # Special macros which affect this process:
368 #%no_install_post_strip 1               # disable stripping at all
369 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
370 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
371 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
372 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
373 #
374 %__spec_install_post_strip {%{!?debug: \
375 %{!?no_install_post_strip:__spec_install_post_strip() { \
376 if [ -d "$RPM_BUILD_ROOT" ]; then \
377         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
378                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
379                 if [ "$modulelist" ]; then \
380                         modulecount=$(echo "$modulelist" | wc -l); \
381                         printf "Stripping %d kernel modules..." $modulecount; \
382                         echo "$modulelist" | xargs -l512 chmod u+w; \
383                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
384                         echo "DONE"; \
385                 fi; \
386         fi; \
387         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
388         if [ -n "$filelist" ]; then \
389                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
390                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
391                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
392                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
393                 if [ -n "$elfexelist" ]; then \
394                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
395                         chmod u+w $elfexelist; \
396                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
397                         echo "DONE"; \
398                 fi; \
399                 if [ -n "$elfsharedlist" ]; then \
400                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
401                         chmod u+w $elfsharedlist; \
402                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
403                         echo "DONE"; \
404                 fi; \
405                 if [ -n "$archiveslist" ]; then \
406                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
407                         chmod u+w $archiveslist; \
408                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
409                         echo "DONE"; \
410                 fi; \
411         fi; \
412     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
413     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
414     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
415         if [ -n "$filelist_all" ]; then \
416                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
417                 chmod u+w $filelist_all; \
418                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
419                 echo "DONE"; \
420         fi; \
421         if [ -n "$filelist_unneeded" ]; then \
422                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
423                 chmod u+w $filelist_unneeded; \
424                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
425                 echo "DONE"; \
426         fi; \
427         if [ -n "$filelist_debug" ]; then \
428                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
429                 chmod u+w $filelist_debug; \
430                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
431                 echo "DONE"; \
432         fi; \
433 fi; }; __spec_install_post_strip } } }
434
435 #-----------------------------------------------------------------
436 # remove all RPATH from executable binaries and shared object files
437 #
438 # Requires: find, awk, cut, xargs, chrpath, uname
439 #
440 # Special macros which affect this process
441 #%no_install_post_chrpath       1       # disable chrpath at all
442 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
443 #
444 %__spec_install_post_chrpath {%{!?debug: \
445 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
446 if [ -d "$RPM_BUILD_ROOT" ]; then \
447         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
448         if [ -n "$files" ]; then \
449                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
450         fi; \
451         if [ -n "$objs" ]; then \
452                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
453                 echo "$objs" | \
454                 while read file; do \
455                         rpath= ; \
456                         chmod u+w "$file"; \
457                         for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
458                                         # translate $ORIGIN to real path, so that normalize path \
459                                         # would work with readlink and secondly we don't need to \
460                                         # relocate the binaries in rpm based distro \
461                                         local f=${file#$RPM_BUILD_ROOT}; \
462                                         local origin=${f%/*}; \
463                                         dir=$(echo $dir | sed -e "s,\$ORIGIN,$origin,g"); \
464                                         dir=$(readlink -m "$dir"); \
465                                         case $dir in \
466                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
467                                                 echo "remove-rpath: $dir in $file"; \
468                                                 ;; \
469                                         * ) \
470                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
471                                                 else rpath="$rpath:$dir" ; fi ; \
472                                                 ;; \
473                                         esac ; \
474                         done ; \
475                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
476                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
477                 done; \
478         fi; \
479 fi; }; __spec_install_post_chrpath } } }
480
481 #-----------------------------------------------------------------
482 # Find and gzip all kernel modules
483 #
484 # Requires: find
485 #
486 #%no_install_post_compress_modules      1
487 %__spec_install_post_compress_modules { \
488 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
489         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
490                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
491                 if [ "$q" ]; then \
492                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
493                         echo "$q" | xargs -r %{__gzip} -9nf; \
494                         echo "DONE"; \
495                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
496                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
497                 fi; \
498         fi; \
499 }; __spec_install_post_compress_modules } }
500
501 # Remove common Perl files we don't package
502 %__spec_install_post_perl_clean {\
503 %{!?no_install_post_perl_clean: \
504 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
505 } }
506
507 #-----------------------------------------------------------------
508 # Update GConf2 schemas
509 #
510 # Requires: GConf2
511 #
512 %gconf_schema_install() \
513         umask 022; \
514         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
515 %{nil}
516
517 %gconf_schema_uninstall() \
518 if [ $1 = 0 ]; then \
519         umask 022; \
520         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
521 fi; \
522 %{nil}
523
524 #-----------------------------------------------------------------
525 # Update desktop MIME database
526 # requires: desktop-file-utils
527 %update_desktop_database() {{ \
528         umask 022; \
529         /usr/bin/update-desktop-database -q; \
530 }}%{nil}
531
532 %update_desktop_database_post %update_desktop_database
533
534 %update_desktop_database_postun() {{ \
535 if [ "$1" = "0" ]; then \
536         %update_desktop_database; \
537 fi; \
538 }}%{nil}
539
540 #-----------------------------------------------------------------
541 # Update shared MIME info database
542 # requires: shared-mime-info
543 #
544 %update_mime_database() {{ \
545         umask 022; \
546         /usr/bin/update-mime-database %{_datadir}/mime; \
547 }}%{nil}
548
549 #-----------------------------------------------------------------
550 # Update icon cache
551 # requires: gtk+
552 #
553 %update_icon_cache() {{ \
554         umask 022; \
555         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
556 }}%{nil}
557
558 #-----------------------------------------------------------------
559 # Update scrollkeeper database
560 # requires: scrollkeeper
561 #
562 %scrollkeeper_update_post() \
563         /usr/bin/scrollkeeper-update -q; \
564 %{nil}
565
566 %scrollkeeper_update_postun() \
567 if [ "$1" = "0" ]; then \
568         /usr/bin/scrollkeeper-update -q; \
569 fi; \
570 %{nil}
571
572 #-----------------------------------------------------------------
573 # post %install sequence:
574 # - autodeps exceptions
575 # - compress all man and info pages,
576 # - strip all ELF executables and ELF shared objects if not %debug.
577 # - compress kernel modules if any
578
579 ###################################################################
580 # Requires/Provides automation
581 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
582 #
583 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
584 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
585 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
586 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
587 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
588
589 #%_noautocompressdoc    %{nil}
590 #
591 %_missing_doc_files_terminate_build     1%{nil}
592 %_unpackaged_files_terminate_build      %{nil}
593 # (X)emacs support
594 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
595 %_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
596 %_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
597
598 %__php_provides %{nil}
599 %__php_requires %{nil}
600 %__perl_provides %{nil}
601 %__perl_requires %{nil}
602 %__mono_provides %{nil}
603 %__mono_requires %{nil}
604
605 # Perl specific macro definitions.
606 %perl_privlib           %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
607 %perl_archlib           %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
608 %perl_vendorlib         %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
609 %perl_vendorarch        %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
610 %perl_sitelib           %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
611 %perl_sitearch          %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
612
613 # Ruby
614 %__ruby                         /usr/bin/ruby
615 %ruby_archdir           %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
616 %ruby_ridir                     %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
617 %ruby_rubylibdir        %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
618 %ruby_vendorarchdir     %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
619 %ruby_vendorlibdir      %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
620 %ruby_sitearchdir       %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
621 %ruby_sitelibdir        %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
622 %ruby_version           %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
623 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
624 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
625
626 %php_pear_dir           /usr/share/pear
627 %php_extensiondir       %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
628 %php_sysconfdir         %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
629 %php_includedir         %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
630
631 # extract php/zend api versions
632 %php_major_version              %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
633 %php_api_version                %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
634 %php_pdo_api_version    %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
635 %php_debug                              %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
636 %zend_module_api                %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
637 %zend_extension_api             %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
638 %zend_zts                               %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
639
640 # helper macro
641 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
642
643 # macros for public use
644 # for php extensions (php-pecl)
645 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
646 %{__php_api_requires zend_module_api} \
647 %{__php_api_requires -v %php_major_version debug php_debug} \
648 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
649
650 # for zend extensions
651 %requires_zend_extension %{__php_api_requires zend_module_api} \
652 %{__php_api_requires zend_extension_api} \
653 %{__php_api_requires -v %php_major_version debug php_debug} \
654 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
655
656 # for php pdo modules (php-pecl-PDO_*)
657 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
658
659 # for using PHP post scripts. for PHP >= 5.0
660 %php_webserver_restart \
661 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
662 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
663 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
664         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
665         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
666                 %service -q php-fcgi restart \
667         fi \
668 fi \
669 %{nil}
670
671 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
672 %php4_webserver_restart \
673 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
674 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
675 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
676         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
677         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
678                 %service -q php-fcgi restart \
679         fi \
680 fi \
681 %{nil}
682
683
684 # X.org helper macros
685 %__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
686 #
687 %xorg_xserver_ansic_abi         %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
688 %xorg_xserver_extension_abi     %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
689 %xorg_xserver_font_abi          %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
690 %xorg_xserver_videodrv_abi      %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
691 %xorg_xserver_xinput_abi        %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
692
693 %requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
694 %{__xorg_abi_requires extension xorg_xserver_extension_abi}
695 %requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
696 %{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
697 %requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
698 %{__xorg_abi_requires font xorg_xserver_font_abi}
699 %requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
700 %{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
701
702 # Python specific macro definitions.
703 # python main version
704 %py_ver                 %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" || echo ERROR)}%py_ver
705
706 # directories
707 %py_prefix              %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" || echo ERROR)}%py_prefix
708 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
709 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
710 %py_incdir              /usr/include/python%{py_ver}
711 %py_sitedir             %{py_libdir}/site-packages
712 %py_sitescriptdir %{py_scriptdir}/site-packages
713 %py_dyndir              %{py_libdir}/lib-dynload
714
715 # pure python modules compilation
716 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
717
718 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
719
720 # Software written in Python language require Python with main version
721 %pyrequires_eq() Requires:      %1
722
723 # Hardlink binary identical .pyc and .pyo files
724 # (idea by glen <at> pld-linux <dot> org)
725 %__spec_install_post_py_hardlink {\
726 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
727 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
728         b="${a%.pyc}.pyo"; \
729         if cmp -s "$a" "$b"; then \
730                 ln -f "$a" "$b"; \
731         fi; \
732 done \
733 }; __spec_install_post_py_hardlink } }
734
735 # remove python sources, so that check-files won't complain
736 # (idea by glen <at> pld-linux <dot> org)
737 %py_postclean() \
738 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
739  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
740 done \
741 %{nil}
742
743 # depmod macro
744 %depmod() { \
745 umask 022; \
746 if [ -e /boot/System.map-%1 ]; then \
747         /sbin/depmod -a -F /boot/System.map-%1 %1; \
748 else \
749         if [ -e /boot/System.map ]; then \
750                 /sbin/depmod -a -F /boot/System.map %1; \
751         else \
752                 /sbin/depmod -a %1; \
753         fi \
754 fi; \
755 }
756
757 # XMMS specific macros
758 %xmms_prefix                    %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
759 %xmms_exec_prefix               %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
760 %xmms_version                   %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
761 %xmms_datadir                   %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
762 %xmms_plugindir                 %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
763 %xmms_visualization_plugindir   %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
764 %xmms_input_plugindir           %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
765 %xmms_output_plugindir          %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
766 %xmms_effect_plugindir          %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
767 %xmms_general_plugindir         %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
768
769 %_target_base_arch      %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
770
771 # user/group checking macros
772 #
773 # Usage:
774 #       %userremove myuser
775 #
776 %userremove     /usr/lib/rpm/user_group.sh user del
777 %groupremove    /usr/lib/rpm/user_group.sh group del
778 #
779 # Usage:
780 #       if %usertestrm myuser; then
781 #               /usr/sbin/userdel -r myuser
782 # Note:
783 #       use these macros only if you need to call userdel/groupdel with
784 #       a non-standard option or take an extra action; otherwise use the
785 #       %userremove/%groupremove macros
786 #
787 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
788 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
789 # user group membership management macros
790 #
791 # Usage:
792 #       %addusertogroup myuser agroup
793 #
794 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
795
796 # banner support (useful in {pre,post}{,un} and triggers)
797 #
798 # Usage:
799 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
800 # the banner text, the banner text
801 # the banner text, and following line
802 #EOF
803 # You can use any form of here-document, <<'EOF' <<-EOT will do.
804 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
805 #
806 # -a   - append to the banner
807 # -e   - send to stderr instead of stdout
808 # -n   - no show banner (overrides -t)
809 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
810 #
811 # Tests:
812 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
813 # rpm -E 'date | %banner -e banner' > m; sh -x m
814 #
815 %banner(aent:) ( \
816 RPM_SCRIPTVERBOSITY=5 \
817 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
818 if [ -x /usr/bin/banner.sh ]; then \
819         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
820 else \
821         CMD="cat%{-e: >&2}" \
822 fi \
823 eval $CMD %{?2:%2}%{?3: %3}) \
824 %{nil}
825
826 # useradd/groupadd macros
827 # Author: Elan Ruusamäe <glen@pld-linux.org>
828 #
829 # Usage:
830 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
831 #   [-g initial_group] [-G group[,...]] login
832 #
833 #  -u uid. REQUIRED
834 #  -g gid/group. REQUIRED
835 #  -s defaults to /bin/false
836 #  -d defaults to /usr/share/empty
837 #  -c No default
838 #  -r is accepted but ignored (it's always set)
839 #  -k skeleton dir. defaults to /usr/share/empty
840 # rpm specific flags
841 #  -P package name. defaults to %{name}
842 #
843 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
844 %{!-u:%{error:useradd: Required argument -u missing}} \
845 %{!-g:%{error:useradd: Required argument -g missing}} \
846 %{!?1:%{error:useradd: Required parameter login missing}} \
847 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
848         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
849                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
850                 exit 1 \
851         fi \
852 else \
853         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
854         /usr/sbin/useradd \\\
855                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
856                 -u %{-u*} \\\
857                 -r \\\
858                 -d %{-d*}%{!-d:/usr/share/empty} \\\
859                 -s %{-s*}%{!-s:/bin/false} \\\
860                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
861                 -g %{-g*} \\\
862                 %{-M} \\\
863                 %{-G:-G %{-G*}} \\\
864                 %{expand:%{%{#}}} 1>&2 || exit $? \
865         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
866 fi;
867
868 # Usage:
869 #   %groupadd [-P package] [-g gid] group
870 #
871 # -g gid. REQUIRED
872 #
873 # Sample:
874 #   %groupadd -P %{name}-base -g %{gid} %{name}
875
876 %groupadd(g:P:rfo)      \
877 %{!-g:%{error:groupadd: Required argument -g missing}} \
878 %{!?1:%{error:groupadd: Required parameter group missing}} \
879 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
880         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
881                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
882                 exit 1 \
883         fi \
884 else \
885         echo "Adding group %{1} GID=%{-g*}." \
886         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
887         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
888 fi;
889
890 # webapp macros
891 # Author: Elan Ruusamäe <glen@pld-linux.org>
892 #
893 # The config is installed/removed inside trigger, this means that you can any
894 # time install apache1/apache/lighttpd package and the configuration file is
895 # updated. if you don't need the config for various reason for specific
896 # webserver, just remove the symlink from config directory using webapp
897 # program. the trigger will not recreate the symlink on upgrades. In other
898 # words the config is linked to webserver config directory on first install of
899 # PACKAGE or WEBSERVER.
900 #
901 # Add package's webserver config to webserver webapps dir.
902 # Usage:
903 #   %webapp_register WEBSERVER WEBAPP
904 #
905 %webapp_register() \
906 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
907 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
908         /usr/sbin/webapp register %1 %2\
909 fi\
910 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
911 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
912         %{expand:%service -q %%1 reload}\
913 fi\
914 %{nil}
915
916 # Remove package's config from webserver webapps dir.
917 # Usage:
918 #   %webapp_register [-f] WEBSERVER WEBAPP
919 %webapp_unregister(f) \
920 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
921 # remove link if either of the packages are gone \
922 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
923         /usr/sbin/webapp unregister %1 %2\
924         %{expand:%service -q %%1 reload}\
925 fi \
926 %{nil}
927
928 # service macro.
929 # Author: Elan Ruusamäe <glen@pld-linux.org>
930 #
931 # calls usual service restart on package %post, but skips the restart if
932 # administrator has disabled automatic service restarts in either global
933 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
934 #
935 # Usage:
936 #   %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
937 #
938 #  -q be silent when service isn't started (for scriplets restaring other package's services)
939 #  -n NOOP mode, do not actually restart service
940 #
941 # Requirements:
942 # BuildRequires:        rpmbuild(macros) >= 1.268
943 # Requires:     rc-scripts
944 # -n option:
945 # BuildRequires:        rpmbuild(macros) >= 1.450
946 %service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
947
948
949 # Java macros. based on jpackage macros.java
950 #
951 # Root directory where all Java VMs/SDK/JREs are installed.
952 %_jvmdir                %{_libdir}/jvm
953
954 # Root directory where all Java VMs/SDK/JREs expose their jars
955 %_jvmjardir             %{_libdir}/jvm-exports
956
957 # Root directory for all Java VM/SDK/JRE's private things.
958 %_jvmprivdir    %{_libdir}/jvm-private
959
960 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
961 %_jvmlibdir             %{_libdir}/jvm
962
963 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
964 %_jvmdatadir    %{_datadir}/jvm
965
966 # Root directory for all configurations parts of Java VM/SDK/JRE's
967 %_jvmsysconfdir %{_sysconfdir}/jvm
968
969 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
970 %_jvmcommonlibdir       %{_libdir}/jvm-common
971
972 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
973 %_jvmcommondatadir      %{_datadir}/jvm-common
974
975 # Root directory for all common configurations parts of Java VM/SDK/JRE's
976 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
977
978 # Directory where arch-specific (JNI) version-independent jars are installed.
979 %_jnidir                %{_libdir}/java
980
981 %java_home              %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
982
983 %ant                    JAVA_HOME=%{java_home} ant
984 %jar                    %{java_home}/bin/jar
985 %java                   %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
986 %javac                  %{java_home}/bin/javac
987 %javadoc                %{java_home}/bin/javadoc
988
989 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
990
991 %jpackage_script() \
992 install -d $RPM_BUILD_ROOT%{_bindir}\
993 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
994 #!/bin/sh\
995 #\
996 # %{name} script\
997 # JPackage Project <http://www.jpackage.org/>\
998 \
999 # Source functions library\
1000 . %{_javadir}-utils/java-functions\
1001 \
1002 # Source system prefs\
1003 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1004     . %{_sysconfdir}/java/%{name}.conf\
1005 fi\
1006 \
1007 # Source user prefs\
1008 if [ -f $HOME/.%{name}rc ]; then\
1009     . $HOME/.%{name}rc\
1010 fi\
1011 \
1012 # Configuration\
1013 MAIN_CLASS=%1\
1014 BASE_FLAGS=%2\
1015 BASE_OPTIONS=%3\
1016 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1017 \
1018 # Set parameters\
1019 set_jvm\
1020 set_classpath $BASE_JARS\
1021 set_flags $BASE_FLAGS\
1022 set_options $BASE_OPTIONS\
1023 \
1024 # Let's start\
1025 run "$@"\
1026 EOF
1027
1028 # jpackage 1.7
1029 # Directory for maven depmaps
1030 #
1031 %_mavendepmapdir /etc/maven
1032 %_mavendepmapfragdir /etc/maven/fragments
1033
1034 #
1035 # add_to_depmap adds an entry to the depmap. The arguments are:
1036 #
1037 # %1 the original groupid
1038 # %2 the original artifact id
1039 # %3 the version
1040 # %4 the new groupid
1041 # %5 the new artifactid
1042 #
1043
1044 %add_to_maven_depmap() \
1045 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1046 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1047 <dependency>\
1048     <maven>\
1049         <groupId>%1</groupId>\
1050         <artifactId>%2</artifactId>\
1051         <version>%3</version>\
1052     </maven>\
1053     <jpp>\
1054         <groupId>%4</groupId>\
1055         <artifactId>%5</artifactId>\
1056         <version>%3</version>\
1057     </jpp>\
1058 </dependency>\
1059 \
1060 EOF\
1061 %{nil}
1062
1063 #==============================================================================
1064 #
1065 # update_maven_depmap updates the main maven depmap
1066 #
1067 %update_maven_depmap() \
1068 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1069 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1070 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1071 fi\
1072 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1073
1074
1075 # PEAR install macros
1076 # Author: Elan Ruusamäe <glen@pld-linux.org>
1077 #
1078 # Usage:
1079 #       %%pear_package_setup [-a #] [-n FMT]
1080 #
1081 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1082 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1083 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1084 #
1085 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1086 # destination hierarchy. you should copy the tree to buildroot after
1087 # patching/reorganizing with %%pear_package_install.
1088 #
1089 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1090 # line endings.
1091 #
1092 # the pear install process output is recorded to install.log, you should put it
1093 # to %%doc for later debug or just for information.
1094 #
1095 # additionally additional-packages.txt is produced if it was detected that the
1096 # package has optional dependencies. the file format is suitable of displaying
1097 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1098 # automatically added for this file.
1099
1100
1101 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1102 %__pear_install_log \
1103 tee install.log \
1104 # make post message of optional packages \
1105 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1106 if [ -s optional-packages.txt ]; then \
1107         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1108 else \
1109         rm -f optional-packages.txt \
1110 fi \
1111 %{nil}
1112
1113 # command invoking pear cli
1114 %__pear /usr/bin/pear
1115
1116 %pear_install(a:n:zD) \
1117 %__pear \\\
1118         -c pearrc \\\
1119         -d doc_dir=/docs \\\
1120         -d php_dir=%{php_pear_dir} \\\
1121         -d bin_dir=%{_bindir} \\\
1122         -d data_dir=%{php_pear_dir}/data \\\
1123         -d test_dir=%{php_pear_dir}/tests \\\
1124         install \\\
1125         --packagingroot=%{builddir} \\\
1126         --offline \\\
1127         --nodeps \\\
1128         %{-f:--force} \\\
1129         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1130 %{nil}
1131
1132 # The main macro.
1133 # using this macro will append optional-packages.txt to the nocompressdoc list
1134 # as it's displayed to user after package install. and adding additional gzip
1135 # dep is just waste ;)
1136 %pear_package_setup(a:n:zD) \
1137 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1138 %define builddir %{_builddir}/%{srcdir} \
1139 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1140 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1141 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1142 %pear_install \
1143 %{-z:cd ..} \
1144 cat %{-z:$_N/}.install.log | %__pear_install_log \
1145 \
1146 # undos sources \
1147 find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1148 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1149 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1150 %{nil}
1151
1152 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1153 # Author: Elan Ruusamäe <glen@pld-linux.org>
1154 %pear_package_install() \
1155 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1156 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1157 # help the developer out a little: \
1158 if [ -f _noautoreq ]; then \
1159         echo "AutoReqdep detected:" \
1160         echo "_noautoreq $(cat _noautoreq)" \
1161 fi \
1162 %{nil}
1163
1164
1165 # Register OpenLDAP schema.
1166 # Author: Elan Ruusamäe <glen@pld-linux.org>
1167 #
1168 # Usage:
1169 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1170 #
1171 #  -d specify dependant schemas, separated by comma
1172 #
1173 %openldap_schema_register(d:) \
1174 for schema in %*; do \
1175         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1176                 %{__sed} -i -e " \
1177                         /^include.*local.schema/{ \
1178                                 iinclude\\t     $schema\
1179                         } \
1180                 " /etc/openldap/slapd.conf \
1181         fi \
1182 done \
1183 # enable dependant schemas \
1184 if [ "%{-d*}" ]; then \
1185         %{__sed} -i -e ' \
1186         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1187                 s/^#// \
1188         }' /etc/openldap/slapd.conf \
1189 fi \
1190 %{nil}
1191
1192 # Unregister OpenLDAP schema.
1193 # Author: Elan Ruusamäe <glen@pld-linux.org>
1194 #
1195 # Usage:
1196 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1197 #
1198 %openldap_schema_unregister() \
1199 for schema in %*; do \
1200         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1201                 %{__sed} -i -e " \
1202                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1203                 # for symmetry it would be nice if we disable enabled schemas in post, \
1204                 # but we really can not do that, it would break something else. \
1205                 " /etc/openldap/slapd.conf \
1206         fi \
1207 done \
1208 %{nil}
1209
1210 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1211
1212
1213 # Build modules for kernels 2.6
1214 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1215 #
1216 # Usage:
1217 #       %build_kernel_modules -m <modules> -C <directory>
1218 #
1219 #  remember that proper Makefile is still required
1220 # Options:
1221 #  -m <modules> (required) -- comma-separated list of modules to save,
1222 #               without .ko extension, may be placed in subdirectory
1223 #  -C <directory> -- change to <directory> before doing anything
1224 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1225 #  -c -- do not execute make clean
1226 #  <additional arguments> -- all additional arguments will be passed to
1227 #               make modules
1228 #
1229 # Additional patching supported via here document. Try:
1230 #       %build_kernel_modules -m module <<'EOF'
1231 #       your patch script here
1232 #       EOF
1233 # Don't use it unless patching depends on config options.
1234
1235 # Developer note: don't touch it unless you know how to handle '\'.
1236 # - \ in script expands to nothing
1237 # - \\\ in script expands to \
1238 # - \\\ inside definition expands to nothing
1239 # - \\\\\\\ inside definition expands to \
1240 # - in last line \ has to touch arguments so arguments passing
1241 #   in new lines (using \) will be supported
1242
1243 %build_kernel_modules(p:P:m:C:c)                                                                        \
1244 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1245                                                                                                                                         \
1246 %define Opts                                                                                                            \\\\\\\
1247 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1248         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1249         CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
1250         %else                                                                                                                   \\\
1251         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1252         %endif                                                                                                                  \\\
1253 %else                                                                                                                           \\\
1254         CC="%{kgcc}"                                                                                                    \\\
1255 %endif                                                                                                                          \
1256 %define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1257                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1258                                                                                                                                         \
1259 %{?-C:cd %{-C*}}                                                                                                        \
1260 compile() {                                                                                                                     \
1261         local L="<" PATCH_SH;                                                                                   \
1262         [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"                   \
1263         set -e -x                                                                                                               \
1264         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1265                                                                                                                                         \
1266 for cfg in ${cfgs:-dist}; do                                        \
1267         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1268                                                                                                                                         \
1269         rm -rf o                                                                                                                \
1270         install -d o/include/linux                                                                              \
1271         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1272         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1273         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1274                                                                                                                                         \
1275         set +x                                                                                                                  \
1276         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1277         set -x                                                                                                                  \
1278                                                                                                                                         \
1279         %if %{with dist_kernel}                                                                                 \
1280                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1281                         %{-p*} %{-P*}                                                                                   \\\
1282                         %{MakeOpts}                                                                                             \
1283         %else                                                                                                                   \
1284                 install -d o/include/config                                                                     \
1285                 touch o/include/config/MARKER                                                           \
1286                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1287         %endif                                                                                                                  \
1288                                                                                                                                         \
1289         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1290                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1291                 ${1+"$@"}                                                                                                       \\\
1292                 M=$PWD %{MakeOpts}}                                                                                     \
1293                                                                                                                                         \
1294         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1295                 ${1+"$@"}                                                                                                       \\\
1296                 M=$PWD %{MakeOpts}                                                                                      \
1297                                                                                                                                         \
1298         for MODULE in {%{-m*},}; do                                                                             \
1299                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1300         done                                                                                                                    \
1301 done                                                                                                                            \
1302 %{?-C:cd -}                                                                                                                     \
1303 }                                                                                                                                       \
1304 compile %{*}\
1305 %{nil}
1306
1307
1308 # Install kernel modules built by %build_kernel_modules
1309 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1310 #
1311 # Usage:
1312 #       %install_kernel_modules -m <modules> -d <directory>
1313 #
1314 # Options:
1315 #  -m <modules> (required) -- comma-separated list of modules to install,
1316 #               without .ko extension, may be placed in subdirectory
1317 #  -d <directory> (required) -- in what subdirectory modules should be
1318 #               installed (eg. misc, kernel/drivers/net)
1319 #  -s <suffix> -- suffix to use when installing modules, useful when module
1320 #               with same name exists in kernel already
1321 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1322 #               for defining aliases, only useful with -s
1323
1324 %install_kernel_modules(m:d:s:n:)                                                                       \
1325 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1326 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1327 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1328                                                                                                                                         \
1329 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1330 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1331                                                                                                                                         \
1332 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1333                                                                                                                                         \
1334 for MODULE in {%{-m*},}; do                                                                                     \
1335         [ -n "${MODULE}" ] || continue                                                                  \
1336         for cfg in ${cfgs:-dist}; do                                    \
1337                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1338                 MNAME=${MODULE##*/}                                                                                     \
1339                 install -D ${MODULE}-$cfg.ko                                                            \\\
1340                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1341                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1342                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1343                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1344         done                                                                                                                    \
1345 done                                                                                                                            \
1346 %{nil}
1347
1348 # patchset macros
1349 # Author: Elan Ruusamäe <glen@pld-linux.org>
1350 #
1351 # Usage:
1352 #   %patchset_source -f <seq(1) format> <start> [<end>]
1353 #   %patchset_patch <start> [<end>]
1354 #
1355 # If <end> is omited, it is assumed to be <start>.
1356 #
1357 # For example in preamble:
1358 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1359 # and in %prep:
1360 #  %patchset_patch 33 44
1361
1362 # generate SourceX urls from range START STOP
1363 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1364 # The sources start from 10000
1365 %patchset_source(f:b:) %(
1366         base=%{-b*}%{!-b*:10000};
1367         start=$(expr $base + %1);
1368         end=$(expr $base + %{?2}%{!?2:%{1}});
1369         # we need to call seq twice as it doesn't allow two formats
1370         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1371         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1372         paste %{tmpdir}/__ps{1,2};
1373         rm -f %{tmpdir}/__ps{1,2};
1374 ) \
1375 %{nil}
1376
1377 # apply sources from %patchset_source
1378 # -p specify -pX for %patch line
1379 # -b base offset: defaults to 10000
1380 %patchset_patch(f:p:b:) %(
1381         base=%{-b*}%{!-b*:10000};
1382         start=$(expr $base + %1);
1383         end=$(expr $base + %{?2}%{!?2:%{1}});
1384         echo ": patchset_patch %1%{?2: to %2}";
1385         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1386 ) \
1387 %{nil}
1388
1389 # browser plugins v2
1390 # Author: Elan Ruusamäe <glen@pld-linux.org>
1391 #
1392 # Usage:
1393 #       %browser_plugins_add_browser <name> -p <plugindir>
1394 #
1395 #  <name> (required) -- name of the browser. usually %{name}.
1396 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1397 #  -b -- default blacklists
1398 #  -a <arch> override arch
1399 #
1400 # Example:
1401 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1402
1403 %_browserpluginsconfdir         /etc/browser-plugins
1404 %_browserpluginsdir                     %{_libdir}/browser-plugins
1405 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1406
1407 %browser_plugins_add_browser(p:b:a:) \
1408         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1409         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1410         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1411         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1412         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1413         %{-b:cat >> $blacklist_file %{-b*}} \
1414 %{nil}
1415
1416 # Helper for LUA.
1417 # split string separated by space into quoted list
1418 #
1419 # Author: Elan Ruusamäe <glen@pld-linux.org>
1420 #
1421 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1422 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1423
1424 # adjust /etc/shells by adding and removing shells from there
1425 # Author: Elan Ruusamäe <glen@pld-linux.org>
1426 #
1427 # Usage:
1428 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1429 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1430 #
1431 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1432 #
1433 # Requirements:
1434 # BuildRequires:        rpmbuild(macros) >= 1.429
1435
1436 %add_etc_shells(p) %{-p:<lua>}\
1437 t = {}\
1438 f = io.open("/etc/shells", "r")\
1439 if f then\
1440         for l in f:lines() do t[l]=l; end\
1441         f:close()\
1442 end\
1443 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1444         if not t[s] then\
1445                 print("Adding "..s.." to /etc/shells")\
1446                 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1447         end\
1448 end\
1449 %{nil}
1450
1451 %remove_etc_shells(p) %{-p:<lua>}\
1452 %{-p:if arg[2] == 0 then}\
1453         t = {}\
1454         f = io.open("/etc/shells", "r")\
1455         if f then\
1456                 for l in f:lines() do t[l]=l; end\
1457                 f:close()\
1458         end\
1459         for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1460                 print("Removing "..l.." from /etc/shells")\
1461                 t[l] = nil\
1462         end\
1463         s=""\
1464         for _, l in pairs(t) do\
1465                 s=s..l.."\\n"\
1466         end\
1467         io.open("/etc/shells", "w"):write(s)\
1468 %{-p:end} \
1469 %{nil}
1470
1471 # vim:ts=4 sw=4 noet syn=spec
This page took 0.317226 seconds and 4 git commands to generate.